# -*- coding: utf-8 -*-
"""DetrendFinalBase.

This file is automatically generated. Do not modify!
"""

from micado.dataitems.CatalogableBase import CatalogableBase, persistent
from micado.dataitems.DetrendBase import DetrendBase
from micado.dataitems.Background import Background
from micado.dataitems.IllumCorr import IllumCorr
from micado.recipes.McdImgDetrendFinal import McdImgDetrendFinal
from micado.dataitems.DetrendFinalExtension import DetrendFinalExtension


class DetrendFinalBase(CatalogableBase):
    """DetrendFinalBase.

    Image which has been corrected for instrumental effects, and background
    subtracted.
    """

    dummy_detrendfinalbase = persistent("dummy [][None]", int, 42)

    det_dit = persistent(
        "Detector integration time (average when NDIT > 1) [DET DIT][s]", float, 1.0
    )

    filtname = persistent("Filter name [INS FILT NAME][None]", str, "")

    mjdobs = persistent(
        "Modified Julian Day of the start of the exposure. The MJD is related "
        "to the Julian Day (JD) via the formula: MJD = JD-2400000.5 The comment"
        " includes a civil representation of the date and time. 8 decimals are "
        "required for a precision of one millisecond, 5 decimals for a "
        "precision of one second. [MJD-OBS][]",
        float,
        0.0,
    )

    tpl__start = persistent("Start time of template [TPL START][None]", float, 0.0)

    ra = persistent("Right Ascension [OBS RA][deg]", float, 0.0)

    dec = persistent("Declination [OBS DEC][deg]", float, 0.0)

    detrend = persistent("Detrended Science Image [][None]", DetrendBase, None)

    background = persistent("Background to subtract [][None]", Background, None)

    illum = persistent("Illumination Correction [][None]", IllumCorr, None)

    recipe = persistent("The recipe [][None]", McdImgDetrendFinal, None)

    extensions = persistent(
        "DetrendFinalExtensions [][None]", DetrendFinalExtension, []
    )
