# -*- coding: utf-8 -*-
"""Hardware that represents an effect."""

from micado.main.Hardware import Hardware


class EffectExtra(Hardware):
    """Hardware that represents an effect.

    This class is necessary to overload scopesim_dictionary.
    """

    @property
    def scopesim_dictionary(self):
        """Create ScopeSIM dictionary from value."""
        dd = super(EffectExtra, self).scopesim_dictionary
        kwargs1 = dd.pop("kwargs")
        # Convert from OrderedDict to dict.
        # Do not pass empty values, e.g. filename, globalname.
        kwargs2 = {
            # TODO: Fix realfilename hack.
            k.replace("realfilename", "filename"): v
            for k, v in kwargs1.items()
            if v not in ["", None]
        }

        # TODO: Place in FilterCurveExtra.py?
        if "filter_name" in kwargs2 and "filename_format" not in kwargs2:
            kwargs2["filename_format"] = "filters/TC_filter_{}.dat"

        dd["kwargs"] = kwargs2
        return dd
