# -*- coding: utf-8 -*-
"""Tests for template generation."""
import black
import pytest

from micado.templates.MicadoImgCalDark import MicadoImgCalDark
from micado.toolbox.python_from_tsf import (
    PATH_TEMPLATE_TSF,
    PATH_TEMPLATE_PY,
    template_from_tsf,
)
from micado.toolbox.tsf_from_python import tsf_from_template


@pytest.mark.xfail(reason="TODO: Add all attribute to dark, also from template.")
def test_python_from_tsf():
    """Test generation of Python classes from TSF files."""
    s_generated = template_from_tsf(PATH_TEMPLATE_TSF / "MICADO_img_cal_dark.tsf")
    s_existing = open(PATH_TEMPLATE_PY / "MicadoImgCalDark.py").read()
    m = black.FileMode()
    s_generated_b = black.format_str(s_generated.strip(), mode=m)
    s_existing_b = black.format_str(s_existing.strip(), mode=m)
    assert s_existing_b == s_generated_b


def test_tsf_from_python():
    """Test generation of TSF files from Python classes."""
    s_generated = tsf_from_template(MicadoImgCalDark)
    s_existing = open(PATH_TEMPLATE_TSF / "MICADO_img_cal_dark.tsf").read()
    assert s_existing.strip() == s_generated.strip()
